Autopep8 in pre-commit git - how to auto-resume?

I have a pre-commit git hook that runs autopep8

on python sensory files. My problem is that: # If there are whitespace errors,

it print

s the offending file names and fail

s .

(see below.)

Question:

How do I make it re-add and re-commit files that I am currently manually fixing?

Thank!

#!/bin/bash


#
# An example hook script to verify what is about to be committed.
# Called by "git commit" with no arguments.  The hook should
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-commit".

if git rev-parse --verify HEAD >/dev/null 2>&1
then
    against=HEAD
else
    # Initial commit: diff against an empty tree object
    against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi

# If you want to allow non-ascii filenames set this variable to true.
allownonascii=$(git config hooks.allownonascii || echo false)

# Redirect output to stderr.
exec 1>&2

# Cross platform projects tend to avoid non-ascii filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
    # Note that the use of brackets around a tr range is ok here, (it's
    # even required, for portability to Solaris 10 /usr/bin/tr), since
    # the square bracket bytes happen to fall in the designated range.
    test $(git diff --cached --name-only --diff-filter=A -z $against |
      LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
    echo "Error: Attempt to add a non-ascii file name."
    echo
    echo "This can cause problems if you want to work"
    echo "with people on other platforms."
    echo
    echo "To be portable it is advisable to rename the file ..."
    echo
    echo "If you know what you are doing you can disable this"
    echo "check using:"
    echo
    echo "  git config hooks.allownonascii true"
    echo
    exit 1
fi

# If there are whitespace errors, print the offending file names and fail.
git diff-index --check --cached $against --

touched_python_files=`git diff --cached --name-only |egrep '\.py$' || true`
if [ -n "$touched_python_files" ]; then
    autopep8 \
        --ignore=E26 \
        --in-place \
        --jobs=0 \
        --max-line-length=150 \
        $touched_python_files
fi

      

+3


source to share


1 answer


This is a modified version of @steven's script.

If the autopep8

file changes, the commit is aborted (so you can make partial differences with git add -p

no problem). The end also stops if it fails for some reason autopep8

.



Unfortunately there is no way to tell from the exit or output state if autopep8

something has changed, so it has to run twice (once for diff, once for editing).

#!/bin/sh

status=0
touched_python_files=$(git diff --cached --name-only | grep -E '\.py$')
if [ -n "$touched_python_files" ]; then
    options="\
      --ignore=E26 \
      --max-line-length=150 \
    "

    output=$(autopep8 -d $options "${touched_python_files[@]}")
    status=$?

    if [ -n "$output" ]; then
        autopep8 -i -j 0 $options "${touched_python_files[@]}"
        echo ">>> autopep8 edited some files <<<"
        exit 1
    fi
fi

exit $status

      

+1


source







All Articles